/*
*  Name:      stack_value.hh
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   UESQL stack value for scanner/parser
*  Date:      $Date: 1999/04/20 14:04:08 $
*  Revision:  $Revision: 1.5 $
*
*  Copyright (C) 1996-1998  Rafael Jesus Alcantara Perez <ralcan@vnet.es>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/

#ifndef _STACK_VALUE__
#define _STACK_VALUE__

#include <mpcl/string.hh>


class TStackValue
{

  public:

    /*
    *  A T T R I B U T E S
    *
    *    yOriginalText
    *      String with original text.
    *
    *    yCode
    *      String with code generated.
    *
    *    iItemCount
    *      Number of items (for parameter lists).
    *
    *    gHasColumnDefinition
    *      True if <column definition> has been reduced to this
    *      no-terminal.
    */

    mpcl::xstring   yOriginalText;
    mpcl::xstring   yCode;
    int             iItemCount;
    bool            gHasColumnDefinition;


  public:

    /*
    *  C O N S T R U C T O R S
    */
 
    TStackValue (void)             :
      yOriginalText        ()      ,
      yCode                ()      ,
      iItemCount           (-1)    ,
      gHasColumnDefinition (false) {}
    /*
    *  Description:  Builds a new instance.
    */

};  /* class TStackValue */

#endif  /* not _STACK_VALUE__ */
