#include "informix-cplus-2.53.UC2.hh"


/*
*  UESQLC::informix-cplus-2.53.UC2 template explicit instantiations.
*/

template class TCollection<string>;
template class TBaseContainer<string>;
template class TLinkedContainer<string>;
template class TCollection<ITConnection*>;
template class TBaseContainer<ITConnection*>;
template class TLinkedContainer<ITConnection*>;
template class TBaseMap<string, ITConnection*>;
template class TLinkedMap<string, ITConnection*>;


/*
*  UESQLC::informix-cplus-2.53.UC2 internal variables initiation.
*/

string         TInformixManager::stSqlInstruction;
ITConnection*   TInformixManager::ptItconnection = NULL;
PGresult*       TInformixManager::ptPgresult     = NULL;
PGresult*       TInformixManager::ptAuxPgresult  = NULL;
char*           TInformixManager::pcHost         = NULL;
char*           TInformixManager::pcDatabaseName = getenv ("USER");


/*
*  C O N S T R U C T O R S
*/

TInformixManager::~TInformixManager (void)
{

  finish();

}  /* ~TInformixManager() */


bool TInformixManager::initiate (void)
{

  bool   gSuccess = gIsThereConnection;

  return gSuccess;

}  /* initiate() */


void TInformixManager::connect (const string& rkyCONNECTION_NAME, const ITConnection* pktCONNECTION)
{

  tConnectionMap.bind (rkyCONNECTION_NAME, pktCONNECTION);
  stCurrentConnection = rkyCONNECTION_NAME;
  gIsThereConnection  = true;

}  /* connect() */


void TInformixManager::disconnect (const string& rkyCONNECTION_NAME)
{

  tConnectionMap [rkyCONNECTION_NAME]->Close();
  tConnectionMap.unbind (rkyCONNECTION_NAME);
  if ( rkyCONNECTION_NAME == stCurrentConnection )
  {
    stCurrentConnection.erase();
    gIsThereConnection = false;
  }

}  /* disconnect() */


void TInformixManager::disconnectCurrent (void)
{

  disconnect (stCurrentConnection);

}  /* disconnect() */


ITConnection* TInformixManager::setCurrentConnection (const string& rkyCONNECTION_NAME)
{

  ITConnection*   ptConnectionItconnection = NULL;

  if ( tConnectionMap.isBinded (rkyCONNECTION_NAME) )
  {
    stCurrentConnection = rkyCONNECTION_NAME;
    ptConnectionItconnection  = tConnectionMap [rkyCONNECTION_NAME];
  }
  return ptConnectionItconnection;

}  /* setCurrentConnection() */


/*
*  S E L E C T O R S
*/

bool TInformixManager::existsDefaultConnection (void) const
{

  return !stCurrentConnection.isEmpty();

}  /* existsDefaultConnection() */


bool TInformixManager::isConnected (const string& rkyCONNECTION_NAME) const
{

  return tConnectionMap.isBinded (rkyCONNECTION_NAME);

}  /* isConnected() */


ITConnection* TInformixManager::currentConnection (void) const
{

  ITConnection*   ptCurrentItconnection = NULL;

  if ( !stCurrentConnection.isEmpty() )
  {
    ptCurrentItconnection = tConnectionMap [stCurrentConnection];
  }
  return ptCurrentItconnection;

}  /* currentConnection() */


ITConnection* TInformixManager::connection (const string& rkyCONNECTION_NAME) const
{

  return tConnectionMap [rkyCONNECTION_NAME];

}  /* connection() */


void TInformixManager::finish (void)
{

  for (register size_t J = 0, zMapCardinal = tConnectionMap.linksCardinal(); ( J < zMapCardinal ) ;J++)
  {
    PQfinish (tConnectionMap.item (J));
  }
  tConnectionMap.erase();
  stCurrentConnection.erase();

}  /* finish() */


