/*
*  Name:      test-general-2.uesql.cc
*  Author:    Rafael Jesus Alcantara Perez
*  Summary:   NIST SQL Test Suite
*  Date:      $Date: 1999/04/20 14:04:19 $
*  Revision:  $Revision: 1.1 $
*
*  The tests contained in this file corresponds to APPENDIX B
*  from NIST SQL Test Suite 5.1. These  tests  mainly  checks
*  the validity of the compiler. The tests that must fail are
*  commented out. The next message comes from the NIST SQL
*  Test Suite Manual. 
*
*
*  NIST SQL Test Suite
*
*    Version 5.1
*    May 1995
*
*
*  Evaluating Conformance to SQL Standards:
*
*    FIPS 127-2
*    ANSI X3.135-1992
*    ISO/IEC 9075:1992
*    X/Open XPG4 SQL
*
*
*  National Institute of Standards and Technology
*  Computer Systems Laboratory
*  Information Systems Engineering Division
*
*
*  Copyright (C) 1996-1998  Rafael Jesus Alcantara Perez <ralcan@vnet.es>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA 02111-1307, USA.
*/
                                        

int main (void)
{

extern "UESQL::default" {

-- NIST SQL Test Suite, V5.0, Schema Definition, schema1.std 
-- 59-byte ID
-- TEd Version #
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID HU ******
-- ***************************************************************

-- This file defines the base tables used in most of the tests.

-- This is a standard schema definition.

  CREATE SCHEMA
  AUTHORIZATION HU

  CREATE TABLE BASE_TESTREPORT
   (TESTNO   CHAR(4),
    RESULT   CHAR(4),
    TESTTYPE  CHAR(3))

  CREATE TABLE HU.ECCO (C1 CHAR(2))

  CREATE TABLE STAFF
   (EMPNUM   CHAR(3) NOT NULL UNIQUE,
    EMPNAME  CHAR(20),
    GRADE    DECIMAL(4),
    CITY     CHAR(15))

  CREATE TABLE PROJ
   (PNUM     CHAR(3) NOT NULL UNIQUE,
    PNAME    CHAR(20),
    PTYPE    CHAR(6),
    BUDGET   DECIMAL(9),
    CITY     CHAR(15))

  CREATE TABLE WORKS
   (EMPNUM   CHAR(3) NOT NULL,
    PNUM     CHAR(3) NOT NULL,
    HOURS    DECIMAL(5),
    UNIQUE(EMPNUM,PNUM))

  CREATE TABLE FIPS1
   (FIPS_TEST CHAR(20))



  CREATE TABLE STAFF1 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15))

  CREATE TABLE PROJ1 (PNUM    CHAR(3) NOT NULL UNIQUE,
                PNAME  CHAR(20),
                PTYPE  CHAR(6),
                BUDGET DECIMAL(9),
                CITY   CHAR(15))

  CREATE TABLE WORKS1(EMPNUM    CHAR(3) NOT NULL,
                PNUM    CHAR(3) NOT NULL,
                HOURS   DECIMAL(5),
                UNIQUE(EMPNUM, PNUM))

  CREATE TABLE STAFF3 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15))

  CREATE TABLE STAFF4 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15))

  CREATE TABLE LONGINT (LONG_INT DECIMAL(15))

  CREATE TABLE TEMP_S

     (EMPNUM  CHAR(3),
      GRADE DECIMAL(4),
      CITY CHAR(15))

  CREATE TABLE TMP (T1 CHAR (10), T2 DECIMAL(2), T3 CHAR (10))

  CREATE TABLE AA (CHARTEST     CHAR(20))

  CREATE TABLE BB (CHARTEST     CHAR)

  CREATE TABLE CC (CHARTEST     CHARACTER(20))

  CREATE TABLE DD (CHARTEST     CHARACTER)

  CREATE TABLE EE (INTTEST     INTEGER)

  CREATE TABLE FF (INTTEST     INT)

  CREATE TABLE GG (REALTEST     REAL)

  CREATE TABLE HH (SMALLTEST  SMALLINT)

  CREATE TABLE II (DOUBLETEST  DOUBLE PRECISION)

  CREATE TABLE JJ (FLOATTEST  FLOAT)

  CREATE TABLE KK (FLOATTEST  FLOAT(32))

  CREATE TABLE LL (NUMTEST  NUMERIC(13,6))

  CREATE TABLE MM (NUMTEST  NUMERIC)

  CREATE TABLE MM2 (NUMTEST NUMERIC(10))

  CREATE TABLE NN (NUMTEST  NUMERIC(9))

  CREATE TABLE OO (NUMTEST  NUMERIC(9))

  CREATE TABLE PP (NUMTEST  DECIMAL(13,6))

  CREATE TABLE QQ (NUMTEST  DECIMAL)

  CREATE TABLE RR (NUMTEST  DECIMAL(8))

  CREATE TABLE SS (NUMTEST  DEC(13,6))

  CREATE TABLE P1 (NUMTEST  NUMERIC(1))

  CREATE TABLE P7 (NUMTEST  NUMERIC(7))

  CREATE TABLE P12 (NUMTEST  NUMERIC(12))

  CREATE TABLE P15 (NUMTEST  NUMERIC(15))

  CREATE TABLE VTABLE
         (COL1   INTEGER,
          COL2   INTEGER,
          COL3   INTEGER,
          COL4   INTEGER,
          COL5   DECIMAL(7,2))

  CREATE TABLE UPUNIQ (NUMKEY  DECIMAL(3) NOT NULL UNIQUE,
                           COL2    CHAR(2))

  CREATE TABLE TEXT80  (TEXXT CHAR(80))
  CREATE TABLE TEXT132  (TEXXT CHAR(132))
  CREATE TABLE TEXT240  (TEXXT CHAR(240))
  CREATE TABLE TEXT256  (TEXXT CHAR(256))
  CREATE TABLE TEXT512  (TEXXT CHAR(512))
  CREATE TABLE TEXT1024  (TEXXT CHAR(1024))

-- The following tables are used to test the limitations (12-14-88)


  CREATE TABLE T240(STR240 CHAR(240))

  CREATE TABLE DEC15(COL1 DECIMAL(15,7))

  CREATE TABLE FLO15(COL1 FLOAT(15))

  CREATE TABLE INT10(COL1 INTEGER, COL2 SMALLINT)

  CREATE TABLE T100(C1 CHAR(2),C2 CHAR(2),C3 CHAR(2),C4 CHAR(2),
                C5 CHAR(2),C6 CHAR(2),C7 CHAR(2),C8 CHAR(2),
                C9 CHAR(2),C10 CHAR(2),C11 CHAR(2),C12 CHAR(2),
                C13 CHAR(2),C14 CHAR(2),C15 CHAR(2),C16 CHAR(2),
                C17 CHAR(2),C18 CHAR(2),C19 CHAR(2),C20 CHAR(2),
                C21 CHAR(2),C22 CHAR(2),C23 CHAR(2),C24 CHAR(2),
                C25 CHAR(2),C26 CHAR(2),C27 CHAR(2),C28 CHAR(2),
                C29 CHAR(2),C30 CHAR(2),C31 CHAR(2),C32 CHAR(2),
                C33 CHAR(2),C34 CHAR(2),C35 CHAR(2),C36 CHAR(2),
                C37 CHAR(2),C38 CHAR(2),C39 CHAR(2),C40 CHAR(2),
                C41 CHAR(2),C42 CHAR(2),C43 CHAR(2),C44 CHAR(2),
                C45 CHAR(2),C46 CHAR(2),C47 CHAR(2),C48 CHAR(2),
                C49 CHAR(2),C50 CHAR(2),C51 CHAR(2),C52 CHAR(2),
                C53 CHAR(2),C54 CHAR(2),C55 CHAR(2),C56 CHAR(2),
                C57 CHAR(2),C58 CHAR(2),C59 CHAR(2),C60 CHAR(2),
                C61 CHAR(2),C62 CHAR(2),C63 CHAR(2),C64 CHAR(2),
                C65 CHAR(2),C66 CHAR(2),C67 CHAR(2),C68 CHAR(2),
                C69 CHAR(2),C70 CHAR(2),C71 CHAR(2),C72 CHAR(2),
                C73 CHAR(2),C74 CHAR(2),C75 CHAR(2),C76 CHAR(2),
                C77 CHAR(2),C78 CHAR(2),C79 CHAR(2),C80 CHAR(2),
                C81 CHAR(2),C82 CHAR(2),C83 CHAR(2),C84 CHAR(2),
                C85 CHAR(2),C86 CHAR(2),C87 CHAR(2),C88 CHAR(2),
                C89 CHAR(2),C90 CHAR(2),C91 CHAR(2),C92 CHAR(2),
                C93 CHAR(2),C94 CHAR(2),C95 CHAR(2),C96 CHAR(2),
                C97 CHAR(2),C98 CHAR(2),C99 CHAR(2),C100 CHAR(2))

  CREATE TABLE T2000(STR110 CHAR(110),STR120 CHAR(120),
                   STR130 CHAR(130),STR140 CHAR(140),
                   STR150 CHAR(150),STR160 CHAR(160),
                   STR170 CHAR(170),STR180 CHAR(180),
                   STR190 CHAR(190),STR200 CHAR(200),
                   STR210 CHAR(210),STR216 CHAR(216))

  CREATE TABLE T8(COL1 CHAR(2) NOT NULL,COL2 CHAR(4) NOT NULL,
                COL3 CHAR(6) NOT NULL,COL4 CHAR(8) NOT NULL,
                COL5 CHAR(10) NOT NULL,COL6 CHAR(12) NOT NULL,
                COL7 CHAR(14),COL8 CHAR(16),
                UNIQUE(COL1,COL2,COL3,COL4,COL5,COL6))

  CREATE TABLE T118(STR118 CHAR(118) NOT NULL UNIQUE)

  CREATE TABLE T4(STR110 CHAR(110) NOT NULL,
                NUM6   NUMERIC(6) NOT NULL,
                COL3   CHAR(10),COL4 CHAR(20),
                UNIQUE(STR110,NUM6))

  CREATE TABLE T12(COL1 CHAR(1), COL2 CHAR(2),
                 COL3 CHAR(4), COL4 CHAR(6),
                 COL5 CHAR(8), COL6 CHAR(10),
                 COL7 CHAR(20), COL8 CHAR(30),
                 COL9 CHAR(40), COL10 CHAR(50),
                 COL11 INTEGER, COL12 INTEGER)

  CREATE TABLE NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                         DOLLARS INTEGER)

  CREATE TABLE SV (NUMTEST NUMERIC(8,3))

  CREATE TABLE JJ_20 (FLOATTEST  FLOAT(20))

  CREATE TABLE PP_15 (NUMTEST  DECIMAL(15,15))

  CREATE TABLE PP_7  (NUMTEST  DECIMAL(15,7))

  CREATE TABLE P15_15 (NUMTEST  NUMERIC(15,15))

  CREATE TABLE P15_7 (NUMTEST  NUMERIC(15,7))

  CREATE TABLE TEMP_OBSERV
               (YEAR_OBSERV  NUMERIC(4),
                CITY         CHAR(10),
                MAX_TEMP     NUMERIC(5,2),
                MIN_TEMP     NUMERIC(5,2))

  CREATE TABLE TOKENS
    (PROG_NO INT, TOKEN_NO INT)

  CREATE TABLE WHICH_SCHEMA1 (C1 CHAR (50))

-- ************* create view statements follow *************

   CREATE VIEW TESTREPORT AS
    SELECT TESTNO, RESULT, TESTTYPE

    FROM BASE_TESTREPORT


   CREATE VIEW CELSIUS_OBSERV (CITY, YEAR_OBSERV, MIN_C, MAX_C)
      AS SELECT CITY, YEAR_OBSERV, (MIN_TEMP - 32) * 5 / 9,
                (MAX_TEMP - 32) * 5 / 9
         FROM TEMP_OBSERV

   CREATE VIEW MULTI_YEAR_OBSERV (CITY, HIGH, LOW)
      AS SELECT CITY, AVG(MAX_TEMP), AVG(MIN_TEMP)
            FROM TEMP_OBSERV
            GROUP BY CITY

   CREATE VIEW EXTREME_TEMPS (YEAR_OBSERV, HIGH, LOW)
      AS SELECT YEAR_OBSERV, MAX(MAX_TEMP), MIN(MIN_TEMP)
            FROM TEMP_OBSERV
            GROUP BY YEAR_OBSERV

       CREATE VIEW SET_TEST (EMP1, EMP_AVG, EMP_MAX) AS
           SELECT STAFF.EMPNUM, AVG(HOURS), MAX(HOURS)
           FROM STAFF, WORKS
           GROUP BY STAFF.EMPNUM

       CREATE VIEW DUP_COL (EMP1, PNO, HOURS, HOURS_2) AS
           SELECT EMPNUM, PNUM, HOURS, HOURS * 2
           FROM WORKS

  CREATE VIEW STAFFV1
           AS SELECT * FROM STAFF
              WHERE  GRADE >= 12

  CREATE VIEW STAFFV2
           AS SELECT * FROM STAFF
              WHERE  GRADE >= 12
           WITH CHECK OPTION

  CREATE VIEW STAFFV2_VIEW
           AS SELECT *
              FROM   STAFFV2
              WHERE  CITY = 'Vienna'

  CREATE VIEW DOMAIN_VIEW
           AS SELECT *
              FROM   WORKS
              WHERE  EMPNUM = 'E1' AND HOURS = 80
                  OR EMPNUM = 'E2' AND HOURS = 40
                  OR EMPNUM = 'E4' AND HOURS = 20
              WITH CHECK OPTION

  CREATE VIEW STAFF2
           AS SELECT *
              FROM   STAFF
           WITH CHECK OPTION

  CREATE VIEW STAFF_WORKS_DESIGN (NAME,COST,PROJECT)
    AS SELECT EMPNAME,HOURS*2*GRADE,PNAME
     FROM   PROJ,STAFF,WORKS
     WHERE  STAFF.EMPNUM=WORKS.EMPNUM
        AND WORKS.PNUM=PROJ.PNUM
        AND PTYPE='Design'


  CREATE VIEW SUBSP (EMPNUM,PNUM,HOURS)
     AS SELECT EMPNUM,PNUM,HOURS
        FROM   WORKS
        WHERE  EMPNUM='E3'
     WITH CHECK OPTION

  CREATE VIEW TEMP_SS(EMPNUM,GRADE,CITY)
     AS SELECT EMPNUM,GRADE,CITY
        FROM   STAFF
        WHERE  GRADE > 12
     WITH CHECK OPTION

  CREATE VIEW V_WORKS1
           AS SELECT * FROM WORKS
              WHERE HOURS > 15
           WITH CHECK OPTION

  CREATE VIEW V_WORKS2
           AS SELECT * FROM V_WORKS1
              WHERE EMPNUM = 'E1'
                 OR EMPNUM = 'E6'

  CREATE VIEW V_WORKS3
           AS SELECT * FROM V_WORKS2
              WHERE PNUM = 'P2'
                 OR PNUM = 'P7'
           WITH CHECK OPTION

  CREATE VIEW UPDATE_VIEW1
            AS SELECT ALL CITY
                     FROM PROJ

  CREATE VIEW UPDATE_VIEW2
            AS SELECT HOURS, EMPNUM, PNUM
                     FROM WORKS
                     WHERE HOURS IN (10, 20, 40)

  CREATE VIEW UPDATE_VIEW3
            AS SELECT *
                     FROM WORKS
                     WHERE PNUM BETWEEN 'P2' AND 'P4'
                     AND EMPNUM NOT BETWEEN 'E2' AND 'E3'

  CREATE VIEW UPDATE_VIEW4
            AS SELECT PNUM, EMPNUM
                     FROM WORKS
                     WHERE PNUM LIKE '_2%'

  CREATE VIEW UPDATE_VIEW5
            AS SELECT *
                     FROM STAFF
                     WHERE EMPNAME IS NOT NULL AND CITY IS NULL

  CREATE VIEW UPDATE_VIEW6
            AS SELECT EMPNAME, CITY, GRADE
                     FROM STAFF

                     WHERE EMPNAME >= 'Betty' AND EMPNUM < 'E35'
                       OR CITY <= 'Deale' AND GRADE > 12
                       OR GRADE = 13 AND CITY <> 'Akron'

  CREATE VIEW UPDATE_VIEW7
            AS SELECT EMPNAME, CITY, GRADE
                     FROM STAFFV2
                     WHERE EMPNAME >= 'Betty' AND EMPNUM < 'E35'
                       OR CITY <= 'Deale' AND GRADE > 12
                       OR GRADE = 13 AND CITY <> 'Akron'

  CREATE VIEW UPDATE_VIEW8
            AS SELECT MYTABLE.EMPNUM, MYTABLE.EMPNAME
                     FROM STAFF MYTABLE
                     WHERE MYTABLE.GRADE = 12

  CREATE VIEW UPDATE_VIEW9
            AS SELECT EMPNAME, CITY, GRADE
                     FROM STAFF
                     WHERE NOT EMPNAME >= 'Betty' AND EMPNUM <= 'E35'
                       OR NOT (CITY <= 'Deale') AND GRADE > 9
                       AND NOT (GRADE = 13 AND CITY <> 'Akron')
                       OR NOT CITY IN ('Vienna','New York','Deale')

   CREATE VIEW VSTAFF3 AS SELECT * FROM STAFF3

-- ************* grant statements follow *************

   GRANT SELECT ON HU.ECCO TO PUBLIC

   GRANT INSERT ON TESTREPORT TO PUBLIC WITH GRANT OPTION
   GRANT ALL PRIVILEGES ON TESTREPORT TO SUN, XOPEN1 WITH GRANT OPTION

   GRANT SELECT ON STAFF TO SULLIVAN1 WITH GRANT OPTION
   GRANT ALL PRIVILEGES ON STAFF
           TO PUBLIC

   GRANT SELECT ON WORKS
           TO PUBLIC

   GRANT SELECT ON PROJ
           TO PUBLIC

   GRANT SELECT,UPDATE ON WORKS
           TO CUGINI
           WITH GRANT OPTION

   GRANT SELECT,UPDATE ON STAFF2
           TO SULLIVAN

   GRANT SELECT,UPDATE(EMPNUM,EMPNAME) ON STAFF3
           TO SULLIVAN, CUGINI, FLATER, SULLIVAN1
           WITH GRANT OPTION

   GRANT SELECT,INSERT, DELETE ON STAFF4

           TO SULLIVAN, CUGINI, FLATER, SULLIVAN1

   GRANT INSERT ON UPUNIQ TO SULLIVAN

   GRANT SELECT,UPDATE(EMPNUM,EMPNAME) ON VSTAFF3
    TO FLATER WITH GRANT OPTION

   GRANT ALL PRIVILEGES ON HH TO SCHANZLE

   GRANT ALL PRIVILEGES ON FF TO SCHANZLE

   GRANT ALL PRIVILEGES ON P1 TO SCHANZLE

   GRANT ALL PRIVILEGES ON P15 TO FLATER

   GRANT ALL PRIVILEGES ON T100 TO FLATER

   GRANT ALL PRIVILEGES ON TOKENS TO PUBLIC

   GRANT UPDATE (COL1) ON VTABLE TO FLATER;


-- ************* End of Schema *************
-- NIST SQL Test Suite, V5.0, Schema Definition, schema2.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID CUGINI
-- ***************************************************************

-- This is a standard schema definition.

     CREATE SCHEMA AUTHORIZATION CUGINI

     GRANT SELECT,UPDATE ON HU.WORKS
           TO SULLIVAN

      CREATE TABLE VTABLE
            (COL1  INTEGER,
             COL2  INTEGER,
             COL3  INTEGER,
             COL4  INTEGER,
             COL5  DECIMAL(7,2))

     GRANT ALL PRIVILEGES ON VTABLE TO HU

--  Test GRANT without grant permission below -- expect error message
--  "WITH GRANT OPTION" purposefully omitted from HU's GRANT on STAFF4.
--  Do not change file SCHEMA1 to allow "WITH GRANT OPTION" on STAFF4.

     GRANT SELECT, INSERT, DELETE ON HU.STAFF4
           TO SCHANZLE


  CREATE TABLE AA (CHARTEST     CHAR(20))
  CREATE VIEW VAA AS SELECT * FROM AA

  CREATE TABLE BB (CHARTEST     CHAR)
  CREATE VIEW VBB AS SELECT * FROM BB

  CREATE TABLE CC (CHARTEST     CHARACTER(20))
  CREATE VIEW VCC AS SELECT * FROM CC

  CREATE TABLE DD (CHARTEST     CHARACTER)
  CREATE VIEW VDD AS SELECT * FROM DD

  CREATE TABLE EE (INTTEST     INTEGER)

  CREATE TABLE FF (INTTEST     INT)
  CREATE TABLE GG (C1 INT)
  CREATE TABLE HH (SMALLTEST  SMALLINT)

  CREATE TABLE II (C1 INT)
  CREATE VIEW VII AS SELECT * FROM II

  CREATE TABLE JJ (C1 INT)
  CREATE TABLE SRCH1 (C1 INT)
  CREATE TABLE BADG1 (C1 INT)

  CREATE TABLE BADG2 (C1 INT)
  CREATE VIEW VBADG2 AS SELECT * FROM BADG2

  CREATE VIEW VVTABLE AS SELECT * FROM VTABLE

   GRANT SELECT ON AA TO SCHANZLE
   GRANT SELECT ON VAA TO SCHANZLE
   GRANT INSERT ON BB TO SCHANZLE
   GRANT INSERT ON VBB TO SCHANZLE
   GRANT UPDATE ON CC TO SCHANZLE
   GRANT UPDATE ON VCC TO SCHANZLE
   GRANT DELETE ON DD TO SCHANZLE
   GRANT DELETE ON VDD TO SCHANZLE
   GRANT SELECT ON EE TO PUBLIC
   GRANT INSERT ON FF TO PUBLIC
   GRANT UPDATE ON GG TO PUBLIC
   GRANT DELETE ON HH TO PUBLIC
   GRANT ALL PRIVILEGES ON II TO SCHANZLE
   GRANT ALL PRIVILEGES ON VII TO SCHANZLE
   GRANT ALL PRIVILEGES ON JJ TO PUBLIC
   GRANT INSERT, UPDATE, DELETE ON SRCH1 TO SCHANZLE
   GRANT ALL PRIVILEGES ON BADG1 TO FLATER
   GRANT SELECT ON VBADG2 TO FLATER WITH GRANT OPTION
   GRANT ALL PRIVILEGES ON VVTABLE TO HU;

-- ************* End of Schema *************

-- NIST SQL Test Suite, V5.0, Schema Definition, schema3.std
-- 59-byte ID
-- TEd Version
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID MCGINN **
-- ***************************************************************

     CREATE SCHEMA AUTHORIZATION MCGINN

-- This file contains extensions to the SQL standard.
-- Failure to create this schema is not a deficiency.

-- This file tests extensions to SQL to allow names longer than 18.
-- If a create table or create view statement causes a syntax error,
--      delete that create table or create view statement.

---CREATE TABLE TABLEFGHIJKLMNOPQ19
---  (COL2  INTEGER)

---CREATE TABLE SHORTTABLE
---  (COLUMN123456789IS19  INTEGER)

CREATE TABLE BASETABLE1 (COL1  INTEGER)

---CREATE VIEW VIEWABCDEFGHIKLMN19 (COL3)
---  AS SELECT COL1 FROM BASETABLE1

;
-- ************* End of Schema *************

-- NIST SQL Test Suite, V5.0, Schema Definition, schema4.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ******************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID SULLIVAN1
-- ******************************************************************

-- This is a standard schema definition.

   CREATE SCHEMA AUTHORIZATION SULLIVAN1

   CREATE TABLE AUTH_TABLE (FIRST1 INTEGER, SECOND2 CHAR)

   CREATE VIEW MUL_SCH
       AS SELECT EMPNUM, SECOND2
          FROM HU.STAFF, AUTH_TABLE
          WHERE GRADE = FIRST1

    GRANT ALL PRIVILEGES ON AUTH_TABLE TO HU
    GRANT SELECT ON MUL_SCH TO HU

-- The following tables are used to run concurrency program pairs
--    e.g MPA001 and MPB001 use the tables with prefix MP1_

CREATE TABLE MP1_MM2 (NUMTEST NUMERIC(10))
CREATE TABLE MP1_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP1_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)

CREATE TABLE MP2_MM2 (NUMTEST NUMERIC(10))
CREATE TABLE MP2_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP2_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)

CREATE TABLE MP3_MM2 (NUMTEST NUMERIC(10))
CREATE TABLE MP3_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP3_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)

CREATE TABLE MP4_MM2 (NUMTEST NUMERIC(10))
CREATE TABLE MP4_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP4_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)

CREATE TABLE MP5_AA (ANUM NUMERIC(4))
CREATE TABLE MP5_AA_INDEX (ANUM NUMERIC(4) NOT NULL UNIQUE)
CREATE TABLE MP5_TT (TESTTYPE CHAR(3), KOUNT DECIMAL(4))

-- The following tables are used to run interactive concurrency program pairs.

CREATE TABLE TTT (ANUM NUMERIC(4) NOT NULL UNIQUE, AUTHOR CHAR(1))
CREATE TABLE TT (DOLLARS NUMERIC(4), ANUM NUMERIC(4))
CREATE TABLE AA (ANUM NUMERIC(4))
CREATE TABLE BB (BNUM NUMERIC(4))

--  Test GRANT UPDATE for additional columns beyond those WITH GRANT OPTION.
--  expect error message
--  In SCHEMA1 for USER HU is the following grant:
--         GRANT SELECT,UPDATE(EMPNUM,EMPNAME) ON STAFF3
--          TO ..., SULLIVAN1 WITH GRANT OPTION
-- If the following self-grant by SULLIVAN1 will not compile/execute, delete it.
    GRANT SELECT,UPDATE ON HU.STAFF3
           TO SULLIVAN1
           WITH GRANT OPTION

CREATE TABLE MP6_MM2 (NUMTEST NUMERIC(10))
CREATE TABLE MP6_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP6_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)
CREATE TABLE MP6_AA (ANUM NUMERIC(4))
CREATE TABLE MP6_BB (BNUM NUMERIC(4))

CREATE TABLE MP7_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP7_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)
CREATE TABLE MP7_AA (ANUM NUMERIC(4))
CREATE TABLE MP7_BB (BNUM NUMERIC(4))

CREATE TABLE MP8_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP8_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                           DOLLARS INTEGER)
CREATE TABLE MP8_AA (ANUM NUMERIC(4) NOT NULL, AUTHOR CHAR(1), UNIQUE (ANUM))
CREATE TABLE MP8_BB (NUMTEST NUMERIC(9))

CREATE TABLE MP9_NN (NUMTEST NUMERIC(9))
CREATE TABLE MP9_NEXTKEY (KEYNUM INTEGER, AUTHOR CHAR(1),
                         DOLLARS INTEGER)
CREATE TABLE MP9_AA (ANUM NUMERIC(4))
CREATE TABLE MP9_BB (BNUM NUMERIC(4))

CREATE TABLE USG102 (C1 INT, C_1 INT)
CREATE TABLE USG103 (C1 INT, C_1 INT);

-- ************* End of Schema *************
-- NIST SQL Test Suite, V5.0, Schema Definition, schema5.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- *******************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID FLATER ******
-- *******************************************************************

-- This is a standard schema definition.

   CREATE SCHEMA AUTHORIZATION FLATER

   -- VIEW FR1 tests forward references in schema definitions.  This view
   -- was checked by test 0523 in SDL032; that test was removed prior to
   -- the release of V4.  I personally believe that two-pass SDL processing
   -- is the Right Thing and ought to be required, but I speak only for
   -- myself.
   -- CREATE VIEW FR1 AS SELECT * FROM DV1

   CREATE TABLE CONCATBUF (ZZ CHAR(240))
   CREATE TABLE USIG (C1 INT, C_1 INT)
   CREATE TABLE U_SIG (C1 INT, C_1 INT)

   CREATE VIEW DV1 AS
     SELECT DISTINCT HOURS FROM HU.WORKS

   -- This small one-column table is used to generate an
   -- indicator overflow data exception for SQLSTATE testing.
   -- If the table cannot be created, the test is assumed passed.
   -- Save the error message and then use TEd to delete the CREATE TABLE
   -- as well as the GRANT ALL PRIVILEGES ON TINY TO SCHANZLE below.
   -- Use the following TEd change: del *schema5.sop* /TINY/
   -- Test number 0491 in program DML082 may also need to be deleted.

   CREATE TABLE TINY (C1 CHAR(33000))
   -- For generation of "with check option violation" SQLSTATE.
   CREATE TABLE BASE_WCOV (C1 INT)
   CREATE VIEW WCOV AS SELECT * FROM BASE_WCOV WHERE
     C1 > 0 WITH CHECK OPTION

   CREATE TABLE BASE_VS1 (C1 INT, C2 INT)
   CREATE VIEW VS1 AS SELECT * FROM BASE_VS1 WHERE C1 = 0
   CREATE VIEW VS2 AS
     SELECT A.C1 FROM BASE_VS1 A WHERE EXISTS
       (SELECT B.C2 FROM BASE_VS1 B WHERE B.C2 = A.C1)
   CREATE VIEW VS3 AS
     SELECT A.C2 FROM BASE_VS1 A WHERE A.C2 IN
       (SELECT B.C1 FROM BASE_VS1 B WHERE B.C1 < A.C2)
   CREATE VIEW VS4 AS
     SELECT A.C1 FROM BASE_VS1 A WHERE A.C1 < ALL
       (SELECT B.C2 FROM BASE_VS1 B)
   CREATE VIEW VS5 AS
     SELECT A.C1 FROM BASE_VS1 A WHERE A.C1 < SOME
       (SELECT B.C2 FROM BASE_VS1 B)
   CREATE VIEW VS6 AS
     SELECT A.C1 FROM BASE_VS1 A WHERE A.C1 < ANY
       (SELECT B.C2 FROM BASE_VS1 B)

   GRANT ALL PRIVILEGES ON TINY TO SCHANZLE
   GRANT ALL PRIVILEGES ON BASE_WCOV TO SCHANZLE
   GRANT ALL PRIVILEGES ON WCOV TO SCHANZLE
   GRANT ALL PRIVILEGES ON VS1 TO SCHANZLE

   -- Test granting of privileges that we don't have to start with.
   -- We have GRANT OPTION, but we should not be able to grant unrestricted
   -- update on STAFF3 since our own update is restricted to two columns.
   -- Do not change SCHEMA1 to grant unrestricted update.
   -- * expect error message *
   GRANT SELECT, UPDATE ON HU.STAFF3 TO SCHANZLE

   -- Same thing for views.
   -- * expect error message *
   GRANT SELECT, UPDATE ON HU.VSTAFF3 TO SCHANZLE

   -- See whether GRANT ALL PRIVILEGES gives you GRANT OPTION.
   -- It should not.  GRANT OPTION is not technically a privilege.
   -- * expect error message *
   GRANT SELECT ON CUGINI.BADG1 TO SCHANZLE

   -- See whether GRANT OPTION on a view gives you GRANT OPTION
   -- on the base table.
   -- * expect error message *
   GRANT SELECT ON CUGINI.BADG2 TO SCHANZLE

   -- Delimited identifiers.
   CREATE VIEW "SULLIVAN.SELECT" ("sullivan.select") AS
     SELECT C1 FROM BASE_VS1
   GRANT ALL PRIVILEGES ON "SULLIVAN.SELECT" TO SCHANZLE

   -- Please be aware of the following errata; they are not being
   -- tested here.

   -- Check for erratum which allowed duplicate
   --   <unique constraint definition>s
   -- Reference ISO/IEC JTC1/SC21 N6789 section 11.7 SR7
   --   and Annex E 4
   --
   -- The following should be flagged or rejected:
   -- CREATE TABLE T0512 (C1 INT, C2 INT, C3 INT,
   --   UNIQUE (C1,C2), UNIQUE (C3), UNIQUE (C2,C1))

   -- Check for erratum which allowed recursive view definitions.
   -- Reference ISO/IEC JTC1/SC21 N6789 section 11.19 <view definition> SR4
   --   and Annex E 6
   --
   -- The following should be flagged or rejected:
   -- CREATE VIEW T0513 (C1, C2) AS
   --   SELECT T0513.C2, BASE_VS1.C1 FROM T0513, BASE_VS1
;
   
-- ************* End of Schema *************

-- NIST SQL Test Suite, V5.0, Schema Definition, schema6.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- *******************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID FLATER ******
-- *******************************************************************

-- This is a standard schema definition.

-- This SDL file requires Feature 17 of Transitional SQL (multiple schemas
-- per user).

-- Explicit AUTHORIZATION

   CREATE SCHEMA SHIRLEY_HURWITZ
     AUTHORIZATION FLATER

     CREATE VIEW NOT_AVAILABLE AS
       SELECT TIMESLOT FROM MEETINGS
     CREATE TABLE MEETINGS (TIMESLOT INT, AGENDA CHAR(4))
;

-- Vendors may add a semicolon here or break this into two separate files
-- if need be.

-- Implicit AUTHORIZATION

   CREATE SCHEMA LEN_GALLAGHER
     CREATE TABLE TRAVEL (
       TRAVEL_ORDER CHAR(40) NOT NULL UNIQUE,
       DESTINATION CHAR(40),
       REASON_CODE NUMERIC(9))
     GRANT SELECT ON TRAVEL TO PUBLIC;

-- ************* End of Schema *************
-- NIST SQL Test Suite, V5.0, Schema Definition, schema7.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- **************************************************************
-- ***** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID *********
-- ***** CANWEPARSELENGTH18                             *********
-- **************************************************************

-- This is a standard schema definition.

-- used in program SDL026

CREATE SCHEMA AUTHORIZATION CANWEPARSELENGTH18
CREATE TABLE CHARACTER18TABLE18 (CHARS18NAME18CHARS CHAR(4))
CREATE VIEW  CHARACTERS18VIEW18 (LONGNAME18LONGNAME)
             AS SELECT CHARS18NAME18CHARS
                  FROM CHARACTER18TABLE18
                 WHERE CHARS18NAME18CHARS <> 'long'
;

-- ************* End of Schema *************

-- NIST SQL Test Suite, V5.0, Schema Definition, schema8.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID SUN *****
-- ***************************************************************

-- This file defines the base tables used in most of the CDR tests.

-- This is a standard schema definition.

  CREATE SCHEMA
      AUTHORIZATION SUN

  CREATE TABLE SUN.ECCO (C1 CHAR(2))

  CREATE TABLE STAFF
   (EMPNUM   CHAR(3) NOT NULL,
    EMPNAME  CHAR(20),
    GRADE    DECIMAL(4),
    CITY     CHAR(15))

  CREATE TABLE PROJ
   (PNUM     CHAR(3) NOT NULL,
    PNAME    CHAR(20),
    PTYPE    CHAR(6),
    BUDGET   DECIMAL(9),
    CITY     CHAR(15))

  CREATE TABLE WORKS
   (EMPNUM   CHAR(3) NOT NULL,
    PNUM     CHAR(3) NOT NULL,
    HOURS    DECIMAL(5))

  CREATE TABLE STAFF3
   (EMPNUM   CHAR(3) NOT NULL,
    EMPNAME  CHAR(20),
    GRADE    DECIMAL(4),
    CITY     CHAR(15),
    UNIQUE (EMPNUM))

  CREATE TABLE PROJ3
   (PNUM     CHAR(3) NOT NULL,
    PNAME    CHAR(20),
    PTYPE    CHAR(6),
    BUDGET   DECIMAL(9),
    CITY     CHAR(15),
    UNIQUE (PNUM))

  CREATE TABLE WORKS3
   (EMPNUM   CHAR(3) NOT NULL,
    PNUM     CHAR(3) NOT NULL,
    HOURS    DECIMAL(5),
    FOREIGN KEY (EMPNUM) REFERENCES STAFF3(EMPNUM),
    FOREIGN KEY (PNUM) REFERENCES PROJ3(PNUM))

        CREATE TABLE STAFF4 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20) DEFAULT NULL,
                GRADE DECIMAL(4) DEFAULT 0,
                CITY   CHAR(15) DEFAULT '               ')

        CREATE TABLE STAFF14 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20) DEFAULT USER,
        -- EMPNAME CHAR precision may be changed to implementation-defined
        --              precision for value of USER
                GRADE DECIMAL(4),
                CITY   CHAR(15))

        CREATE TABLE STAFF5 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (GRADE > 0 AND GRADE < 20))

        CREATE TABLE STAFF6 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),

                GRADE DECIMAL(4) CHECK (GRADE > 0 AND GRADE < 20),
                CITY   CHAR(15))

        CREATE TABLE STAFF7 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (GRADE BETWEEN 1 AND 20))

        CREATE TABLE STAFF8 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (EMPNAME IS NOT NULL))

        CREATE TABLE STAFF9 (EMPNUM    CHAR(3) NOT NULL PRIMARY KEY,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                CHECK (EMPNAME NOT LIKE 'T%'))

        CREATE TABLE STAFF10 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (GRADE NOT IN (5,22)))

        CREATE TABLE STAFF11 (EMPNUM    CHAR(3) NOT NULL PRIMARY KEY,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                CHECK (GRADE NOT IN (5,22)
                            AND EMPNAME NOT LIKE 'T%'))

        CREATE TABLE STAFF12 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (NOT GRADE IN (5,22)
                            AND NOT EMPNAME LIKE 'T%'))

        CREATE TABLE STAFF13 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20),
                GRADE DECIMAL(4),
                CITY   CHAR(15),
                PRIMARY KEY (EMPNUM),
                CHECK (NOT EMPNAME IS NULL))

        CREATE TABLE STAFF15 (EMPNUM    CHAR(3),
                EMPNAME  CHAR(20) NOT NULL,
                GRADE DECIMAL(4),
                CITY   CHAR(15))

        CREATE TABLE STAFF16 (EMPNUM    CHAR(3) NOT NULL,
                EMPNAME  CHAR(20) DEFAULT NULL,
                GRADE DECIMAL(4) NOT NULL CHECK (GRADE IN (100,150,200)),
                CITY   CHAR(15), PRIMARY KEY (GRADE,EMPNUM))

        CREATE TABLE SIZ1_P
           (S1   CHAR(3) NOT NULL,
            S2   CHAR(3) NOT NULL,
            S3   DECIMAL(4) NOT NULL,
            S4   CHAR(3) NOT NULL,
            S5   DECIMAL(4) NOT NULL,
            S6   CHAR(3) NOT NULL,
            R1   CHAR(3),
            R2   CHAR(3),
            R3   DECIMAL(4),
            UNIQUE   (S1,S2,S3,S4,S5,S6))

        CREATE TABLE SIZ1_F
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(3),
            F3   DECIMAL(4),
            F4   CHAR(3),
            F5   DECIMAL(4),
            F6   CHAR(3),
            R1   CHAR(3),
            R2   DECIMAL(5),
            R3   DECIMAL(4),
            FOREIGN KEY   (F1,F2,F3,F4,F5,F6)
            REFERENCES SIZ1_P(S1,S2,S3,S4,S5,S6))

        CREATE TABLE SIZ2_P
           (P1   CHAR(3) NOT NULL,
            P2   CHAR(3) NOT NULL,
            P3   DECIMAL(4) NOT NULL,
            P4   CHAR(3) NOT NULL,
            P5   DECIMAL(4) NOT NULL,
            P6   CHAR(3) NOT NULL,
            P7   CHAR(3) NOT NULL,
            P8   DECIMAL(4) NOT NULL,
            P9   DECIMAL(4) NOT NULL,
            P10   DECIMAL(4) NOT NULL,
            P11   CHAR(4),
            UNIQUE (P1),
            UNIQUE (P2),
            UNIQUE (P3),
            UNIQUE (P4),
            UNIQUE (P5),
            UNIQUE (P6),
            UNIQUE (P7),
            UNIQUE (P8),
            UNIQUE (P9),
            UNIQUE (P10))

        CREATE TABLE SIZ2_F1
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P1))

        CREATE TABLE SIZ2_F2
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P2))

        CREATE TABLE SIZ2_F3
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P3))

        CREATE TABLE SIZ2_F4
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P4))

        CREATE TABLE SIZ2_F5
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P5))

        CREATE TABLE SIZ2_F6
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P6))

        CREATE TABLE SIZ2_F7
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P7))

        CREATE TABLE SIZ2_F8
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P8))

        CREATE TABLE SIZ2_F9
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P9))

        CREATE TABLE SIZ2_F10
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            FOREIGN KEY (F1)
            REFERENCES SIZ2_P(P10))

        CREATE TABLE SIZ3_P1
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P2
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P3
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P4
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P5
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P6
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P7
           (F1   CHAR(3) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P8
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P9
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_P10
           (F1   DECIMAL(4) NOT NULL,
            F2   CHAR(8),
            UNIQUE (F1))

        CREATE TABLE SIZ3_F
           (P1   CHAR(3) NOT NULL,
            P2   CHAR(3),
            P3   DECIMAL(4),
            P4   CHAR(3),
            P5   DECIMAL(4),
            P6   CHAR(3),
            P7   CHAR(3),
            P8   DECIMAL(4),
            P9   DECIMAL(4),
            P10   DECIMAL(4),
            P11   CHAR(4),
            FOREIGN KEY (P1)
            REFERENCES SIZ3_P1(F1),
            FOREIGN KEY (P2)
            REFERENCES SIZ3_P2(F1),
            FOREIGN KEY (P3)
            REFERENCES SIZ3_P3(F1),
            FOREIGN KEY (P4)
            REFERENCES SIZ3_P4(F1),
            FOREIGN KEY (P5)
            REFERENCES SIZ3_P5(F1),
            FOREIGN KEY (P6)
            REFERENCES SIZ3_P6(F1),
            FOREIGN KEY (P7)
            REFERENCES SIZ3_P7(F1),
            FOREIGN KEY (P8)
            REFERENCES SIZ3_P8(F1),
            FOREIGN KEY (P9)
            REFERENCES SIZ3_P9(F1),
            FOREIGN KEY (P10)
            REFERENCES SIZ3_P10(F1))

        CREATE TABLE DEPT
                (DNO DECIMAL(4) NOT NULL,
                 DNAME CHAR(20) NOT NULL,
                 DEAN CHAR(30),
                 PRIMARY KEY (DNO),
                 UNIQUE (DNAME))

        CREATE TABLE EMP
                (ENO DECIMAL(4) NOT NULL,
                 ENAME CHAR(20) NOT NULL,
                 EDESC CHAR(30),
                 DNO DECIMAL(4) NOT NULL,
                 DNAME CHAR(20),
                 BTH_DATE  DECIMAL(6) NOT NULL,
                 PRIMARY KEY (ENO),
                 UNIQUE (ENAME,BTH_DATE),
                 FOREIGN KEY (DNO) REFERENCES
                 DEPT(DNO),
                 FOREIGN KEY (DNAME) REFERENCES
                 DEPT(DNAME))

        CREATE TABLE EXPERIENCE
                (EXP_NAME CHAR(20),
                 BTH_DATE DECIMAL(6),
                 WK_DATE  DECIMAL(6),
                 DESCR CHAR(40),
                 FOREIGN KEY (EXP_NAME,BTH_DATE) REFERENCES
                 EMP(ENAME,BTH_DATE))

        -- The following tables, STAFF_M and PROJ_M reference each other.
        -- Table STAFF_M has a "forward reference" to PROJ_M.

        CREATE TABLE STAFF_M
           (EMPNUM   CHAR(3) NOT NULL,
            EMPNAME  CHAR(20),
            GRADE    DECIMAL(4),
            CITY     CHAR(15),
            PRI_WK   CHAR(3),
            UNIQUE   (EMPNUM),
            FOREIGN KEY (PRI_WK)
            REFERENCES PROJ_M(PNUM))

        CREATE TABLE PROJ_M
           (PNUM     CHAR(3) NOT NULL,
            PNAME    CHAR(20),
            PTYPE    CHAR(6),
            BUDGET   DECIMAL(9),
            CITY     CHAR(15),
            MGR   CHAR(3),
            UNIQUE (PNUM),
            FOREIGN KEY (MGR)
            REFERENCES STAFF_M(EMPNUM))

 --     The following table is self-referencing.

        CREATE TABLE STAFF_C
           (EMPNUM   CHAR(3) NOT NULL,
            EMPNAME  CHAR(20),
            GRADE    DECIMAL(4),
            CITY     CHAR(15),
            MGR   CHAR(3),
            UNIQUE   (EMPNUM),
            FOREIGN KEY (MGR)
            REFERENCES STAFF_C(EMPNUM))

        CREATE TABLE STAFF_P
           (EMPNUM   CHAR(3) NOT NULL,
            EMPNAME  CHAR(20),
            GRADE    DECIMAL(4),
            CITY     CHAR(15),
            UNIQUE  (EMPNUM))

        CREATE TABLE PROJ_P
           (PNUM     CHAR(3) NOT NULL,
            PNAME    CHAR(20),
            PTYPE    CHAR(6),
            BUDGET   DECIMAL(9),
            CITY     CHAR(15),
            UNIQUE   (PNUM))

        CREATE TABLE MID1 (P_KEY DECIMAL(4) NOT NULL UNIQUE,
                         F_KEY DECIMAL(4) REFERENCES MID1(P_KEY))

        CREATE TABLE ACR_SCH_P(P1 DECIMAL(4) NOT NULL UNIQUE,
                               P2 CHAR(4))
        CREATE TABLE CHAR_DEFAULT
               (SEX_CODE  CHAR(1)  DEFAULT 'F',
                NICKNAME  CHAR(20) DEFAULT 'No nickname given',
                INSURANCE1 CHAR(5)  DEFAULT 'basic')

   CREATE TABLE EXACT_DEF
               (BODY_TEMP NUMERIC(4,1) DEFAULT 98.6,
                MAX_NUM   NUMERIC(5)   DEFAULT -55555,
                MIN_NUM   DEC(6,6)     DEFAULT .000001)

   CREATE TABLE APPROX_DEF
               (X_COUNT   REAL DEFAULT 1.78E12,
                Y_COUNT   REAL DEFAULT -9.99E10,
                Z_COUNT   REAL DEFAULT 3.45E-11,
                ZZ_COUNT  REAL DEFAULT -7.6777E-7)

   CREATE TABLE SIZE_TAB
               (COL1 CHAR(75)  DEFAULT
'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz0123456789012',
                COL2 INTEGER   DEFAULT -999888777,
                COL3 DEC(15,6) DEFAULT 987654321.123456,
                COL4 REAL      DEFAULT -1.048576E22)

   CREATE TABLE COMMODITY
         (C_NUM INTEGER NOT NULL,
          C_NAME CHAR(7) NOT NULL UNIQUE,
          PRIMARY KEY (C_NUM))

   CREATE TABLE CURRENCY_TABLE
         (CURRENCY CHAR(10) NOT NULL,
          DOLLAR_EQUIV NUMERIC(5, 2),
          PRIMARY KEY (CURRENCY))

   CREATE TABLE MEASURE_TABLE
         (MEASURE CHAR(8) NOT NULL,
          POUND_EQUIV NUMERIC(8,2),
          PRIMARY KEY (MEASURE))

   CREATE TABLE C_TRANSACTION
         (COMMOD_NO INTEGER,
          TOT_PRICE     DECIMAL(12,2),
          CURRENCY  CHAR(10),
          UNITS     INTEGER,
          MEASURE   CHAR(8),
          T_DATE    INTEGER,
          FOREIGN KEY (COMMOD_NO)
           REFERENCES COMMODITY,
          FOREIGN KEY (CURRENCY)
           REFERENCES CURRENCY_TABLE,
          FOREIGN KEY (MEASURE)
           REFERENCES MEASURE_TABLE)

  CREATE TABLE T6118REF (
       COL1 CHAR(20), COL2 CHAR(20),
       COL3 CHAR(20), COL4 CHAR(20),
       COL5 CHAR(23), COL6 NUMERIC (4),
       STR118 CHAR(118) NOT NULL UNIQUE,
       UNIQUE (COL1, COL2, COL4, COL3, COL5, COL6))

  CREATE TABLE T118(STR118 CHAR(118) NOT NULL UNIQUE,
    FOREIGN KEY (STR118) REFERENCES T6118REF (STR118))

  CREATE TABLE T6 (COL1 CHAR(20), COL2 CHAR(20),
                 COL3 CHAR(20), COL4 CHAR(20),
                 COL5 CHAR(23), COL6 NUMERIC (4),
    FOREIGN KEY (COL1, COL2, COL4, COL3, COL5, COL6)
      REFERENCES T6118REF (COL1, COL2, COL4, COL3, COL5, COL6))

-- ********************* create view statements ********************

CREATE VIEW TESTREPORT AS
    SELECT TESTNO, RESULT, TESTTYPE
    FROM HU.TESTREPORT

   CREATE VIEW DOLLARS_PER_POUND (COMMODITY, UNIT_PRICE, FROM_DATE, TO_DATE)
      AS SELECT COMMODITY.C_NAME,

             SUM(TOT_PRICE * DOLLAR_EQUIV) / SUM(UNITS * POUND_EQUIV),
                MIN(T_DATE), MAX(T_DATE)
         FROM C_TRANSACTION, COMMODITY, CURRENCY_TABLE, MEASURE_TABLE
         WHERE C_TRANSACTION.COMMOD_NO = COMMODITY.C_NUM
            AND C_TRANSACTION.CURRENCY = CURRENCY_TABLE.CURRENCY
            AND C_TRANSACTION.MEASURE  = MEASURE_TABLE.MEASURE
         GROUP BY COMMODITY.C_NAME
         HAVING SUM(TOT_PRICE * DOLLAR_EQUIV) > 10000

-- View COST_PER_UNIT for OPTIONAL test 0403
-- Remove view from schema if it causes errors.

   CREATE VIEW COST_PER_UNIT
     (COMMODITY, UNIT_PRICE, CURRENCY, MEASURE)
      AS SELECT COMMODITY, UNIT_PRICE * POUND_EQUIV / DOLLAR_EQUIV,
                CURRENCY, MEASURE
            FROM DOLLARS_PER_POUND, CURRENCY_TABLE, MEASURE_TABLE

        CREATE VIEW STAFF6_WITH_GRADES AS
                          SELECT EMPNUM,EMPNAME,GRADE,CITY
                          FROM STAFF6
                          WHERE GRADE > 0 AND GRADE < 20
                          WITH CHECK OPTION

-- ************** grant statements follow *************
        GRANT SELECT ON SUN.ECCO TO PUBLIC

        GRANT INSERT ON TESTREPORT
             TO PUBLIC

        GRANT REFERENCES ON ACR_SCH_P TO SULLIVAN
              WITH GRANT OPTION

        GRANT ALL PRIVILEGES ON PROJ_P
             TO SULLIVAN

        GRANT ALL PRIVILEGES ON T6118REF TO FLATER

        GRANT ALL PRIVILEGES ON T118 TO FLATER

        GRANT ALL PRIVILEGES ON T6 TO FLATER

--  Test GRANT without grant permission below.
--  "WITH GRANT OPTION" purposefully omitted from SUN's GRANT.
--  Do not insert text "WITH GRANT OPTION"

        GRANT REFERENCES ON STAFF_P
             TO SULLIVAN

        GRANT REFERENCES (C_NUM) ON COMMODITY TO SCHANZLE
;
-- ************* End of Schema *************

-- NIST SQL Test Suite, V5.0, Schema Definition, schema9.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID SULLIVAN
-- ***************************************************************

-- This file defines base tables used in the CDR tests.

-- This is a standard schema definition.

  CREATE SCHEMA
  AUTHORIZATION SULLIVAN

  CREATE TABLE WORKS_P
   (EMPNUM   CHAR(3) REFERENCES SUN.STAFF_P(EMPNUM),
    PNUM     CHAR(3),
    HOURS    DECIMAL(5),
    FOREIGN KEY (PNUM)
    REFERENCES SUN.PROJ_P(PNUM))

  CREATE TABLE TTT(P1 DECIMAL(4) NOT NULL UNIQUE,
                 P2 CHAR(4))

-- ************* grant statements follow *************

   GRANT SELECT ON TTT TO SCHANZLE

   GRANT REFERENCES ON SUN.ACR_SCH_P TO SCHANZLE

--  Test GRANT without grant permission below -- expect error message
--  "WITH GRANT OPTION" purposefully omitted from SUN's GRANT.
--  Do not change file SCHEMA8 to allow "WITH GRANT OPTION" on STAFF_P.

   GRANT REFERENCES ON SUN.STAFF_P TO SCHANZLE
;

-- ************* End of Schema *************
-- NIST SQL Test Suite, V5.0, Schema Definition, schem10.std
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER AUTHORIZATION ID SCHANZLE
-- ***************************************************************

-- This file defines base tables used in the CDR tests.

-- This is a standard schema definition.

  CREATE SCHEMA
  AUTHORIZATION SCHANZLE

  CREATE TABLE ACR_SCH_F(F1 DECIMAL(4),
         F2 CHAR(4),
         FOREIGN KEY (F1)
         REFERENCES SUN.ACR_SCH_P(P1))

-- Test GRANT REFERENCES without grant permission below -- expect error message
 -- "WITH GRANT OPTION" purposefully omitted from SUN's GRANT on STAFF_P
-- Do not change file SCHEMA8 to allow "WITH GRANT OPTION"

   CREATE TABLE TAB5(F15 CHAR(3),
          F5 CHAR(4),
          FOREIGN KEY (F15)
          REFERENCES SUN.STAFF_P(EMPNUM))

-- Test REFERENCES without reference permission below -- expect error message
-- GRANT SELECT by SULLIVAN does not imply GRANT REFERENCES.
-- Do not change file SCHEMA9 to allow "GRANT REFERENCES" on TTT.

   CREATE TABLE TAB6(F16 DECIMAL(4),
          F6 CHAR(4),
          FOREIGN KEY (F16)
          REFERENCES SULLIVAN.TTT(P1))

-- Constraints:  column vs. column

   CREATE TABLE RET_CATALOG (
     VENDOR_ID INT,
     PRODUCT_ID INT,
     WHOLESALE NUMERIC (10,2),
     RETAIL NUMERIC (10,2),
     MARKUP NUMERIC (10,2),
     EXPORT_CODE CHAR(2),
     EXPORT_LICNSE_DATE CHAR(20),
     CHECK (EXPORT_LICNSE_DATE IS NULL OR (
       EXPORT_CODE = 'F1' OR
       EXPORT_CODE = 'F2' OR
       EXPORT_CODE = 'F3'                  )),
     CHECK (EXPORT_CODE <> 'F2' OR WHOLESALE > 10000.00),
     CHECK (RETAIL >= WHOLESALE),
     CHECK (RETAIL = WHOLESALE + MARKUP))

   CREATE VIEW SALE_ITEMS AS
     SELECT * FROM RET_CATALOG
     WHERE MARKUP < WHOLESALE / 10.0
     WITH CHECK OPTION

   CREATE TABLE RASTER
      (C1 INT NOT NULL,
       FOREIGN KEY (C1)
       REFERENCES SUN.COMMODITY (C_NUM))

-- Test REFERENCES without reference permission below -- expect error message
-- GRANT REFERENCES (C_NUM) on COMMODITY by SUN does not imply
--      GRANT REFERENCES (C_NAME).
-- Do not change file SCHEMA8 to allow "GRANT REFERENCES" on column C_NAME.

   CREATE TABLE REFRESH
      (C1 CHAR (7),
       FOREIGN KEY (C1)
       REFERENCES SUN.COMMODITY (C_NAME))

   CREATE TABLE CPBASE
      (KC INT NOT NULL,
       JUNK1 CHAR (10),
       PRIMARY KEY (KC))

   CREATE TABLE CPREF
      (KCR INT,
       JUNK2 CHAR (10),
       FOREIGN KEY (KCR) REFERENCES CPBASE)

   CREATE TABLE FOUR_TYPES
      (T_INT     INTEGER,
       T_CHAR    CHAR(10),
       T_DECIMAL DECIMAL(10,2),
       T_REAL    REAL)
;
-- ************* End of Schema *************
-- X/OPEN Extensions SQL Test Suite, V5.0, Schema Definition, xschema1.smi
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER SCHEMA ID XOPEN1 ******
-- ***************************************************************

-- This file defines the base tables used in most of the tests. It
-- is used for X/Open Testing only.

-- This non-standard schema definition is provided so that
-- implementations which require semicolons to terminate statements,
-- but which are otherwise conforming, can still execute the
-- remaining tests.

-- Users may delete the CREATE SCHEMA statement or add further
-- statements, as necessary, to permit creation of the schema
-- without prejudice to the implementation's X/Open conformance status
-- Implementations which support CREATE UNIQUE INDEX instead of the
-- UNIQUE syntax in this schema definition should use xschema1.nc.

-- Implementations which support CREATE UNIQUE INDEX (instead of UNIQUE
-- syntax found in this schema definition) should use file xschema1.nc.

  CREATE SCHEMA AUTHORIZATION XOPEN1;
  CREATE TABLE XOPEN1.ECCO (C1 CHAR(6));
  CREATE TABLE AAA (A1 CHAR(2), A2 CHAR(2), A3 CHAR(2));
  CREATE TABLE BBB (B1 CHAR(2), B2 CHAR(2), B3 CHAR(2) NOT NULL UNIQUE);
  CREATE TABLE CCC (C1 CHAR(2), C2 CHAR(2), C3 CHAR(2));
  CREATE TABLE CHAR_TEST (COL1 CHAR(254));
  CREATE TABLE INT_TEST (COL1 INTEGER);
  CREATE TABLE SMALL_TEST (COL1 SMALLINT);
  CREATE TABLE REAL_TEST (REF CHAR(1),COL1 REAL);
  CREATE TABLE REAL3_TEST (COL1 REAL,COL2 REAL,COL3 REAL);
  CREATE TABLE DOUB_TEST (REF CHAR(1),COL1 DOUBLE PRECISION);
  CREATE TABLE DOUB3_TEST (COL1 DOUBLE PRECISION,COL2 DOUBLE
     PRECISION,COL3 DOUBLE PRECISION);

-- Users may provide an explicit precision for FLOAT_TEST.COL1

  CREATE TABLE FLOAT_TEST (REF CHAR(1),COL1 FLOAT);

  CREATE TABLE INDEXLIMIT(COL1 CHAR(2), COL2 CHAR(2),
     COL3 CHAR(2), COL4 CHAR(2), COL5 CHAR(2),
     COL6 CHAR(2), COL7 CHAR(2));

  CREATE TABLE WIDETABLE (WIDE CHAR(118));
  CREATE TABLE WIDETAB (WIDE1 CHAR(38), WIDE2 CHAR(38), WIDE3 CHAR(38));

  CREATE TABLE TEST_TRUNC (TEST_STRING CHAR (6));

  CREATE TABLE WARNING(TESTCHAR CHAR(6), TESTINT INTEGER);

  CREATE TABLE TV (dec3 DECIMAL(3), dec1514 DECIMAL(15,14),
                   dec150 DECIMAL(15,0), dec1515 DECIMAL(15,15));

  CREATE TABLE TU (smint SMALLINT, dec1514 DECIMAL(15,14),
                   integr INTEGER, dec1515 DECIMAL(15,15));

  CREATE TABLE STAFF
   (EMPNUM   CHAR(3) NOT NULL UNIQUE,
    EMPNAME  CHAR(20),
    GRADE    DECIMAL(4),
    CITY     CHAR(15));

  CREATE TABLE PROJ
   (PNUM     CHAR(3) NOT NULL UNIQUE,
    PNAME    CHAR(20),
    PTYPE    CHAR(6),
    BUDGET   DECIMAL(9),
    CITY     CHAR(15));

  CREATE TABLE WORKS
   (EMPNUM   CHAR(3) NOT NULL,
    PNUM     CHAR(3) NOT NULL,
    HOURS    DECIMAL(5),
    UNIQUE(EMPNUM,PNUM));

  CREATE TABLE INTS
  (INT1      SMALLINT NOT NULL,
   INT2      SMALLINT NOT NULL);

-- ************* create view statements follow *************

CREATE VIEW TESTREPORT AS
    SELECT TESTNO, RESULT, TESTTYPE
    FROM HU.TESTREPORT;

-- ************* grant statements follow *************
   GRANT SELECT ON XOPEN1.ECCO TO PUBLIC;

   GRANT INSERT ON TESTREPORT TO PUBLIC;

   GRANT ALL PRIVILEGES ON STAFF
           TO PUBLIC;

   GRANT SELECT ON WORKS
           TO PUBLIC;

   GRANT SELECT ON PROJ
           TO PUBLIC;

   GRANT ALL PRIVILEGES ON XOPEN1.AAA TO XOPEN2;
   GRANT SELECT, UPDATE ON XOPEN1.AAA TO XOPEN2 WITH GRANT OPTION;
   GRANT INSERT, DELETE ON XOPEN1.BBB TO XOPEN2 WITH GRANT OPTION;
   GRANT SELECT ON XOPEN1.BBB TO XOPEN2 WITH GRANT OPTION;
   GRANT SELECT, INSERT ON XOPEN1.CCC TO XOPEN2;


-- ************* End of Schema *************

-- X/OPEN Extensions SQL Test Suite, V5.0, Schema Definition, xschema2.smi
-- 59-byte ID
-- TEd Version 
-- date_time print
-- ***************************************************************
-- ****** THIS FILE SHOULD BE RUN UNDER SCHEMA ID XOPEN2 ******
-- ***************************************************************

-- This schema definition must be run after xschema1.smi, this
-- schema file is for X/Open testing only.

-- This non-standard schema definition is provided so that
-- implementations which require semicolons to terminate statements,
-- but which are otherwise conforming, can still execute the
-- remaining tests.

-- Users may delete the CREATE SCHEMA statement or add further
-- statements, as necessary, to permit creation of the schema
-- without prejudice to the implementation's X/Open conformance status

   CREATE SCHEMA AUTHORIZATION XOPEN2;

-- ************* create view statements follow *************

   CREATE VIEW XOPEN2V AS SELECT B1, B2, B3 FROM XOPEN1.BBB;

-- ************* grant statements *************

    GRANT SELECT ON XOPEN2.XOPEN2V TO XOPEN1;

-- ************* End of Schema *************

}

  return 0;

}  /* main() */
